#include "ctype.h"
#include "terminal.h"

#include <stdarg.h>

static int get_level(const char *str)
{
	if (!str || !isdigit(str[0]))
		return 8;
	return str[0] - '0';
}

static int print_flag(char flag, va_list *ap)
{
	switch (flag) {
	case '%':
		return terminal_putchar('%');
	case 'i':
		return terminal_writelong(va_arg(*ap, int));
	case 'd':
		return terminal_writelong(va_arg(*ap, int));
	case 'c':
		return terminal_putchar(va_arg(*ap, int));
	case 's':
		return terminal_writestring(va_arg(*ap, char *));
	}
	return 0;
}

int kvprintf(const char *restrict format, va_list ap)
{
	const char *start = format;
	int ret = 0;

	int level = get_level(format);
	set_color_level(level);
	if (level != 8)
		start++;
	while (*start != '\0') {
		if (*start == '%' && *(start + 1) != '\0') {
			ret += print_flag(*(start + 1), &ap);
			start++;
		} else {
			ret += terminal_putchar(*start);
		}
		start++;
	}
	set_color_level(8);
	update_cursor();
	return ret;
}
